const
N_MAX = 50000;


var
   f	: text;
   no	: byte;
   code	: word;

procedure reverse(n : word; size : word; p : real; isizemin, isizemax : word);
var
   i	   : word;
   z	   : array[1..N_MAX] of byte;
   psum	   : array[0..N_MAX] of word;
   a, b, c : word;
begin
   writeln(f,n);
   psum[0] := 0;
   for i := 1 to size do
   begin
      z[i] := ord(random(1000)<=1000*p);
      psum[i] := psum[i-1] + z[i]
   end;
   for i := 1 to n do
   begin
      repeat
	 a := random(size+1-isizemin)+1;
	 b := random(size-a-isizemin)+a+isizemin
      until (b-a > isizemin) and (b-a < isizemax);
      c := psum[b]-psum[a-1];
      if c = 0 then c := 1;
      writeln(f,a,' ',b,' ',c);
   end;
end;

procedure generate(no : word);
var s_no : string;
begin
   str(no, s_no);
   assign(f,'b'+s_no+'.in');
   rewrite(f);
   randseed := 666+no;
   case no of
    { We try different parameters but the last two should be especially nasty for the quadratic algorithm }
     4	: reverse(20,50,0.1,3,100);
     5	: reverse(1000,10000,0.1,3,1000);
     6	: reverse(50000,50000,0.1,3,50000);
     7	: reverse(50000,50000,0.3,10000,50000);
     8	: reverse(50000,50000,0.5,3,10000);
     9	: reverse(50000,50000,0.7,3,50000);
     10	: reverse(50000,50000,0.5,100,50000);
     11	: reverse(50000,50000,0.7,3,1000);
     12	: reverse(50000,50000,0.9,40000,50000);
     13	: reverse(50000,50000,0.8,49000,50000);
   end;			     
   close(f);
end;

begin
   if paramcount < 1 then 
     for no:=4 to 13 do
       generate(no)
   else begin
     val(paramstr(1), no, code);
     generate(no);
   end
end.
