var f : Text;

procedure WriteTime (T : Integer);
begin
  if T div 60 < 10 then
    Write (f, '0');
  Write (f, T div 60, ':');

  if T mod 60 < 10 then
    Write (f, '0');
  Write (f, T mod 60);
end;

procedure Gen4;
{losowe polaczenia}

const
  INTER = 100;
  CITIES = INTER + 2;

var
  i, j : LongInt;

begin
  WriteLn (f, CITIES);

  {city 1}
  Writeln (f, INTER);
  for i := 1 to INTER do
  begin 
    WriteTime (i * 10);
    Write (f, ' ');
    WriteTime ((i + 1) * 10);
    WriteLn (f, ' ', i + 1);
  end;

  for i := 1 to INTER do
  begin
    WriteLn (f, 24 * 6 - 1);
    for j := 0 to 24 * 6 - 2 do
    begin
      WriteTime (j * 10);
      Write (f, ' ');
      WriteTime ((j + 1) * 10);
      WriteLn (f, ' ', CITIES);
    end;
  end;

  WriteLn (f, 0);
end;

procedure Gen5;
const
  CITIES = 24*60 - 1;

var
  i : Integer;

begin
  WriteLn (f, CITIES);

  {city 1}
  WriteLn (f, 3);

  WriteTime (0);
  Write (f, ' ');
  WriteTime (CITIES);
  WriteLn (f, ' ', CITIES);

  WriteTime (0);
  Write (f, ' ');
  WriteTime (CITIES - 10);
  WriteLn (f, ' ', CITIES);

  WriteLn (f, '00:01 00:02 2');

  {the cities 2..(n-1)}
  for i := 2 to CITIES - 1 do
  begin
    WriteLn (f, 1);
    WriteTime (i);
    Write (f, ' ');
    WriteTime (i+1);
    WriteLn (f, ' ', i + 1);
  end;

  {city n}
  WriteLn (f, 0);
end;

procedure Gen6;
{test wydajnosciowy.
 miasto 1 jest podlaczone do 500 takich samych miast: z kazdego z nich
 co minute odjezdza pociag (jadacy minute) do miasta n
}
const
  CONN_k_n = 24*60 - 2;
  CITIES = 500 + 2;

var
  i, j : Integer;

begin
  WriteLn (f, CITIES);

  {city 1}
  WriteLn (f, CITIES - 2);
  
  for i := 1 to CITIES-2 do
    WriteLn (f, '00:00 00:01 ', i + 1);
  
  {cities 2..n-1}
  
  for j := 2 to CITIES - 1 do
  begin
    WriteLn (f, CONN_k_n);
    for i := 1 to CONN_k_n do
    begin
      WriteTime (i);
      Write (f, ' ');
      WriteTime (i+1);
      WriteLn (f, ' ', CITIES);
    end;
  end;

  {city n}
  WriteLn (f, 0);
end;

procedure Gen7;
{graph with LAYERS layers. In every layer CITIES_IN_LAYER cities.
 from every city connections to all cities in next layer}

const
  LAYERS = 1400;
  CITIES_IN_LAYER = 25;

var
  i, j, k : Integer;

begin
  WriteLn (f, CITIES_IN_LAYER * LAYERS);

  for i := 1 to LAYERS-1 do
    for j := 1 to CITIES_IN_LAYER do
    begin
      WriteLn (f, CITIES_IN_LAYER);
      for k := 1 to CITIES_IN_LAYER do
      begin
        WriteTime (i);
        Write (f, ' ');
        WriteTime (i+1);
        WriteLn (f, ' ', i * CITIES_IN_LAYER + k);
      end;
    end;

  for j := 1 to CITIES_IN_LAYER do
    WriteLn (f, 0);
end;

procedure Gen8;
{to samo co gen_tim7, ale mniejsze dane}

{graph with LAYERS layers. In every layer CITIES_IN_LAYER cities.
 from every city connections to all cities in next layer}

const
  LAYERS = 50;
  CITIES_IN_LAYER = 10;

var
  i, j, k : Integer;

begin
  WriteLn (f, CITIES_IN_LAYER * LAYERS);

  for i := 1 to LAYERS-1 do
    for j := 1 to CITIES_IN_LAYER do
    begin
      WriteLn (f, CITIES_IN_LAYER);
      for k := 1 to CITIES_IN_LAYER do
      begin
        WriteTime (i);
        Write (f, ' ');
        WriteTime (i+1);
        WriteLn (f, ' ', i * CITIES_IN_LAYER + k);
      end;
    end;

  for j := 1 to CITIES_IN_LAYER do
    WriteLn (f, 0);
end;

procedure Gen9;
{duza klika, losowe czasy}

const
  CITIES = 1000;

var
  i, j, k : Integer;
  Departures : array [0..24*60 - 1] of LongInt;

begin
  WriteLn (f, CITIES);

  for j := 0 to 24*60 - 1 do
    Departures [j] := 0;

  for i := 1 to CITIES do
  begin
    WriteLn (f, CITIES - 1);

    for j := 1 to CITIES - 1 do
      Inc (Departures [Random (24 * 60 - 1)]);

    k := 0;

    for j := 1 to CITIES do
      if i <> j then
      begin
        while Departures [k] = 0 do
          k := k + 1;

        Dec (Departures [k]);

        WriteTime (k);
        Write (f, ' ');
        WriteTime (k + Random (24*60 - 1 - k) + 1);
        WriteLn (f, ' ', j);
      end;
  end;
end;

procedure Gen10;
{klika 50 wierzcholkow, losowe czasy}

const
  CITIES = 50;

var
  i, j, k : Integer;
  Departures : array [0..24*60 - 1] of LongInt;

begin
  WriteLn (f, CITIES);

  for j := 0 to 24*60 - 1 do
    Departures [j] := 0;

  for i := 1 to CITIES do
  begin
    WriteLn (f, CITIES - 1);

    for j := 1 to CITIES - 1 do
      Inc (Departures [Random (24 * 60 - 1)]);

    k := 0;

    for j := 1 to CITIES do
      if i <> j then
      begin
        while Departures [k] = 0 do
          k := k + 1;

        Dec (Departures [k]);

        WriteTime (k);
        Write (f, ' ');
        WriteTime (k + Random (24*60 - 1 - k) + 1);
        WriteLn (f, ' ', j);
      end;
  end;
end;

procedure Gen11;
{losowe polaczenia}

const
  CITIES = 300;
  CONN = 500000;

var
  i, j, k, l, t1 : LongInt;
  Progi : array [0..CITIES] of LongInt;
  Odjazdy : array [1..CONN] of LongInt;
  Kub : array [0..CONN] of LongInt;

begin
  WriteLn (f, CITIES);

  for i := 0 to CONN do Kub [i] := 0;

  for i := 1 to CITIES - 1 do
    Inc (Kub [Random (CONN + 1)]);

  k := 0;
  for i := 0 to CONN do
    for l := 1 to Kub [i] do
    begin
      Inc (k);
      Progi [k] := i;
    end;

  Progi [0] := 0;
  Progi [CITIES] := CONN;

  for i := 1 to CITIES do
  begin
    WriteLn (f, Progi [i] - Progi [i - 1]);
    for j := 0 to 24*60 do
      Kub [j] := 0;
    for j := 1 to Progi [i] - Progi [i - 1] do
      Inc (Kub [Random (24*60 - 1)]);

    l := 0;
    for j := 0 to 24*60 do
      for k := 1 to Kub [j] do
      begin
        Inc (l);
        Odjazdy [l] := j;
      end;

    for j := 1 to l do
      begin
        t1 := Odjazdy [j] + Random (24 * 60 - 1 - Odjazdy [j]) + 1;
        WriteTime (Odjazdy [j]);
        Write (f, ' ');
        WriteTime (t1);
        WriteLn (f, ' ', Random (CITIES) + 1);
      end;
  end;
end;

procedure Gen12;
{to samo co tim_11 ale mniej miast (wiecej mozliwosci)}
{losowe polaczenia}

const
  CITIES = 50;
  CONN = 500000;

var
  i, j, k, l, t1 : LongInt;
  Progi : array [0..CITIES] of LongInt;
  Odjazdy : array [1..CONN] of LongInt;
  Kub : array [0..CONN] of LongInt;

begin
  WriteLn (f, CITIES);

  for i := 0 to CONN do Kub [i] := 0;

  for i := 1 to CITIES - 1 do
    Inc (Kub [Random (CONN + 1)]);

  k := 0;
  for i := 0 to CONN do
    for l := 1 to Kub [i] do
    begin
      Inc (k);
      Progi [k] := i;
    end;

  Progi [0] := 0;
  Progi [CITIES] := CONN;

  for i := 1 to CITIES do
  begin
    WriteLn (f, Progi [i] - Progi [i - 1]);
    for j := 0 to 24*60 do
      Kub [j] := 0;
    for j := 1 to Progi [i] - Progi [i - 1] do
      Inc (Kub [Random (24*60 - 1)]);

    l := 0;   
    for j := 0 to 24*60 do
      for k := 1 to Kub [j] do
      begin
        Inc (l); 
        Odjazdy [l] := j;
      end;

    for j := 1 to l do
      begin
        t1 := Odjazdy [j] + Random (24 * 60 - 1 - Odjazdy [j]) + 1;
        WriteTime (Odjazdy [j]);
        Write (f, ' ');
        WriteTime (t1);
        WriteLn (f, ' ', Random (CITIES) + 1);
      end; 
  end;
end;

var i : Integer;
    si : string;
begin
  for i :=4 to 12 do begin
    Str(i, si);
    Assign(f, 'g' + si + '.in');
    Rewrite(f);
    RandSeed := 987 + i;
    case i of
      4: Gen4;
      5: Gen5;
      6: Gen6;
      7: Gen7;
      8: Gen8;
      9: Gen9;
      10: Gen10;
      11: Gen11;
      12: Gen12;
    end;
    Close(f);
  end;
end.
