{* This game is similar to the well known game called NIM.
   In order to solve the task we apply dynamic programming.
   Since the program is very short comments in the text of the
   program should be sufficient.
*}   
 
const 
  Max_n = 200;  

var 
  n, m : integer;

  p : integer;    
  T : array[0..Max_n] of integer; 
  { T[p] -- the maximal number of donuts the first player can eat
            if the game starts w p donuts in the box} 

  S : array[0..Max_n, 0..Max_n] of integer;
  { S[i, j] -- the number of donuts the first player can win
    if the game starts from the state:
    (p-i-j (=l) donuts in the box, the first player has i donuts, 
     the second player has j donuts) }  

  i, j, k, l : integer; { auxiliary variables }

begin
    readln(n,m);
    T[0] := 0;
    for p := 1 to n do begin {counting T[p]}
      for l := 1 to p do 
        for i := 0 to p-l do begin
          j := p-l-i;
          {counting S[i, j]}
          S[i, j] := -maxInt;
	  for k := 1 to m do begin
	    if k < l then begin
	      if S[i, j] < p - S[j, i+k] then 
	        S[i, j] := p - S[j, i+k];
	    end else begin
	      if S[i, j] < p - T[j] then
	        S[i, j] := p - T[j];
	      break
	    end
	end
      end;	
      T[p] := S[0,0]
    end;
    writeln(T[n])   
end.  
